# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with maven

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define short_name      scout
%define section         free

%define real_version    0.7rc2

%define repodir %{_javadir}/repository.jboss.com/apache-scout/%{real_version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           ws-scout0
Version:        0.7
Release:        0.rc2.4%{?dist}
Epoch:          0
Summary:        Apache Scout Implementation of JSR 93 (JAXR)
License:        ASL 2.0
Group:          Text Processing/Markup/XML
URL:            http://ws.apache.org/scout/
# svn export https://svn.apache.org/repos/asf/webservices/scout/tags/v0.7rc2/ ws-scout-0.7rc2 
# tar cjf ws-scout-0.7rc2.tar.bz2 ws-scout-0.7rc2
Source0:        ws-scout-%{real_version}.tar.bz2
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        ws-scout-1.0-jpp-depmap.xml
Source6:        ws-scout-component-info.xml
Source8:        ws-scout0-build.xml
Source9:        ws-scout0-maven-build.xml
Source10:       ws-scout0-modules-scout-build.xml
Source11:       ws-scout0-modules-scout-maven-build.xml
Source12:       ws-scout0-0.7rc2.pom
Patch0:         ws-scout-1.0-jaxr-api-project_xml.patch
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  junit
%if %with maven
BuildRequires:  maven >= 1.0.2
BuildRequires:  maven-plugins-base >= 1.0.2
BuildRequires:  maven-plugin-multiproject >= 1.0.2
BuildRequires:  maven-plugin-license >= 1.0.2
BuildRequires:  maven-plugin-test >= 1.0.2
BuildRequires:  maven-plugin-xdoc >= 1.0.2
BuildRequires:  axis >= 0:1.2
BuildRequires:  jakarta-commons-discovery
BuildRequires:  jakarta-commons-logging
BuildRequires:  jdom
BuildRequires:  saxon-scripts
%else
BuildRequires:  ant
%endif
BuildRequires:  jaf
BuildRequires:  juddi
BuildRequires:  ws-scout
%if %with maven
Requires:       axis >= 0:1.2
Requires:       jakarta-commons-discovery
Requires:       jakarta-commons-logging
Requires:       jdom
%endif
Requires:       jaf
Requires:       juddi
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache Scout is an implementation of the 
JSR 93 (JAXR). 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n ws-scout-%{real_version}

# Already clean
#find . -name "*.jar" | xargs -t rm

cp -a %{SOURCE8} build.xml
cp -a %{SOURCE9} maven-build.xml
cp -a %{SOURCE10} modules/scout/build.xml
cp -a %{SOURCE11} modules/scout/maven-build.xml

# These tests need a running juddi server instance
rm modules/scout/src/test/org/apache/ws/scout/registry/publish/PublishConceptTest.java
rm modules/scout/src/test/org/apache/ws/scout/registry/query/JAXRQueryTest.java

# for checkstyle
cp -p LICENSE.TXT modules/jaxr-api/LICENSE.txt

# Remove log4j.properties file. It is not needed by scout directly, and may 
# cause conflicts/problems with other applications.
rm -f modules/scout/src/conf/log4j.properties

%patch0 -p0

perl -pi -e 's/\r$//g' LICENSE.TXT

%build
%if %with maven
export DEPCAT=$(pwd)/ws-scout-1.0-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    %{_bindir}/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
%{_bindir}/saxon $DEPCAT %{SOURCE2} > ws-scout-1.0-depmap.new.xml
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    %{_bindir}/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done
for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository
pushd modules/jaxr-api
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository javadoc:generate
popd
pushd modules/scout
maven \
        -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository javadoc:generate
popd
%else
export CLASSPATH=$(build-classpath jaf juddi junit ws-scout/jaxr-api log4j)
export OPT_JAR_LIST=:
ant -Dmaven.mode.offline=true package javadoc
%endif
%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
%if %with maven
install -m 644 modules/jaxr-api/target/jaxr-api-1.0-SNAPSHOT.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/jaxr-api-%{version}.jar
install -m 644 modules/scout/target/scout-1.0-SNAPSHOT.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
%else
install -m 644 modules/scout/target/scout-%{real_version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
%endif
# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
ln -sf %{name}-%{version}.jar %{short_name}-%{version}.jar
for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done
)

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %with maven
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jaxr-api
cp -pr modules/jaxr-api/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jaxr-api
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/scout
cp -pr modules/scout/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/scout
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%else
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/scout
cp -pr modules/scout/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/scout
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%endif

# poms
%add_to_maven_depmap scout scout %{version} JPP/%{name} %{name}
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -a %{SOURCE12} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom

%if %{with_repolib}
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{real_version}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/%{short_name}.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.TXT
%{_javadir}/%{name}
%{_datadir}/maven2/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Fri Sep 26 2008 David Walluck <dwalluck@redhat.com> 0:0.7-0.rc2.4
- copy our pom instead of the project pom

* Fri Sep 26 2008 David Walluck <dwalluck@redhat.com> 0:0.7-0.rc2.3
- add pom

* Tue Sep 02 2008 David Walluck <dwalluck@redhat.com> 0:0.7-0.rc2.2
- fix directory ownership

* Tue Aug 19 2008 David Walluck <dwalluck@redhat.com> 0:0.7-0.rc2.1
- release based on 1.0-5
